Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90	(revision 3938)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limupdate2.F90	(revision 3938)
@@ -0,0 +1,615 @@
+MODULE limupdate2
+   !!======================================================================
+   !!                     ***  MODULE  limupdate2  ***
+   !!   LIM-3 : Update of sea-ice global variables at the end of the time step
+   !!======================================================================
+   !! History :  3.0  !  2006-04  (M. Vancoppenolle) Original code
+   !!----------------------------------------------------------------------
+#if defined key_lim3
+   !!----------------------------------------------------------------------
+   !!   'key_lim3'                                      LIM3 sea-ice model
+   !!----------------------------------------------------------------------
+   !!    lim_update2   : computes update of sea-ice global variables from trend terms
+   !!----------------------------------------------------------------------
+   USE limrhg          ! ice rheology
+
+   USE dom_oce
+   USE oce             ! dynamics and tracers variables
+   USE in_out_manager
+   USE sbc_oce         ! Surface boundary condition: ocean fields
+   USE sbc_ice         ! Surface boundary condition: ice fields
+   USE dom_ice
+   USE phycst          ! physical constants
+   USE ice
+   USE limdyn
+   USE limtrp
+   USE limthd
+   USE limsbc
+   USE limdia
+   USE limdiahsb
+   USE limwri
+   USE limrst
+   USE thd_ice         ! LIM thermodynamic sea-ice variables
+   USE par_ice
+   USE limitd_th
+   USE limitd_me
+   USE limvar
+   USE prtctl           ! Print control
+   USE lbclnk           ! lateral boundary condition - MPP exchanges
+   USE wrk_nemo         ! work arrays
+   USE lib_fortran     ! glob_sum
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC   lim_update2   ! routine called by ice_step
+
+      REAL(wp)  ::   epsi06 = 1.e-06_wp   ! module constants
+      REAL(wp)  ::   epsi04 = 1.e-04_wp   !    -       -
+      REAL(wp)  ::   epsi10 = 1.e-10_wp   !    -       -
+      REAL(wp)  ::   epsi16 = 1.e-16_wp   !    -       -
+      REAL(wp)  ::   epsi20 = 1.e-20_wp   !    -       -
+      REAL(wp)  ::   rzero  = 0._wp       !    -       -
+      REAL(wp)  ::   rone   = 1._wp       !    -       -
+         
+   !! * Substitutions
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/LIM3 4.0 , UCL - NEMO Consortium (2011)
+   !! $Id: limupdate.F90 3294 2012-01-28 16:44:18Z rblod $
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE lim_update2
+      !!-------------------------------------------------------------------
+      !!               ***  ROUTINE lim_update2  ***
+      !!               
+      !! ** Purpose :  Computes update of sea-ice global variables at 
+      !!               the end of the time step.
+      !!               Address pathological cases
+      !!               This place is very important
+      !!                
+      !! ** Method  :  
+      !!    Ice speed from ice dynamics
+      !!    Ice thickness, Snow thickness, Temperatures, Lead fraction
+      !!      from advection and ice thermodynamics 
+      !!
+      !! ** Action  : - 
+      !!---------------------------------------------------------------------
+      INTEGER ::   ji, jj, jk, jl, jm    ! dummy loop indices
+      INTEGER ::   jbnd1, jbnd2
+      INTEGER ::   i_ice_switch
+      INTEGER ::   ind_im, layer      ! indices for internal melt
+      REAL(wp) ::   zweight, zesum, zhimax, z_da_i
+      REAL(wp) ::   zindb, zindsn, zindic
+      REAL(wp) ::   zindg, zh, zdvres, zviold2
+      REAL(wp) ::   zbigvalue, zvsold2, z_da_ex
+      REAL(wp) ::   z_prescr_hi, zat_i_old, ztmelts, ze_s
+
+      INTEGER , POINTER, DIMENSION(:,:,:) ::  internal_melt
+      REAL(wp), POINTER, DIMENSION(:) ::   zthick0, zqm0      ! thickness of the layers and heat contents for
+      REAL(wp) :: zchk_v_i, zchk_smv, zchk_fs, zchk_fw, zchk_v_i_b, zchk_smv_b, zchk_fs_b, zchk_fw_b ! Check conservation (C Rousset)
+
+      ! mass and salt flux (clem)
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   zviold, zvsold, zsmvold   ! old ice volume...
+      !!-------------------------------------------------------------------
+
+      CALL wrk_alloc( jpi,jpj,jpl, internal_melt )   ! integer
+      CALL wrk_alloc( jkmax, zthick0, zqm0 )
+
+      CALL wrk_alloc( jpi,jpj,jpl,zviold, zvsold, zsmvold )   ! clem
+
+      !------------------------------------------------------------------------------
+      ! 1. Update of Global variables                                               |
+      !------------------------------------------------------------------------------
+
+      !-----------------------------
+      ! Update ice and snow volumes  
+      !-----------------------------
+      DO jl = 1, jpl
+         v_i(:,:,jl)  = v_i(:,:,jl) + d_v_i_thd(:,:,jl) 
+         v_s(:,:,jl)  = v_s(:,:,jl) + d_v_s_thd(:,:,jl)
+      END DO
+ 
+      !---------------------------------------------
+      ! Ice concentration and ice heat content
+      !---------------------------------------------
+      a_i (:,:,:) = a_i (:,:,:) + d_a_i_thd(:,:,:)
+      e_i(:,:,:,:) = e_i(:,:,:,:) + d_e_i_thd(:,:,:,:)  
+ 
+      !------------------------------
+      ! Snow temperature and ice age
+      !------------------------------
+      e_s (:,:,:,:) = e_s (:,:,:,:) + d_e_s_thd (:,:,:,:)
+      oa_i(:,:,:)   = oa_i(:,:,:)   + d_oa_i_thd(:,:,:)
+
+      !--------------
+      ! Ice salinity    
+      !--------------
+      IF(  num_sal == 2  .OR.  num_sal == 4  ) THEN      ! general case
+         smv_i(:,:,:) = smv_i(:,:,:) + d_smv_i_thd(:,:,:)
+      ENDIF
+
+      ! mass and salt flux init (clem)
+      zviold(:,:,:) = v_i(:,:,:)
+      zvsold(:,:,:) = v_s(:,:,:)
+      zsmvold(:,:,:) = smv_i(:,:,:)
+
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_v_i_b = glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_smv_b = glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) )
+         zchk_fw_b  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) )
+         zchk_fs_b  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) )
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
+
+      CALL lim_var_glo2eqv
+
+      !---------------------------------
+      ! Classify the pathological cases
+      !---------------------------------
+      ! (1) v_i (new) > 0; d_v_i_thd + v_i(old) > 0 (easy case)
+      ! (2) v_i (new) > 0; d_v_i_thd + v_i(old) = 0 (total thermodynamic ablation)
+      ! (3) v_i (new) < 0; d_v_i_thd + v_i(old) > 0 (combined total ablation)
+      ! (4) v_i (new) < 0; d_v_i_thd + v_i(old) = 0 (total thermodynamic ablation 
+      ! with negative advection, very pathological )
+      !
+      DO jl = 1, jpl
+         DO jj = 1, jpj
+            DO ji = 1, jpi
+               patho_case(ji,jj,jl) = 1
+               IF( v_i(ji,jj,jl) .GE. 0.0 ) THEN
+                  IF ( old_v_i(ji,jj,jl) + d_v_i_thd(ji,jj,jl) .LT. epsi10 ) THEN 
+                     patho_case(ji,jj,jl) = 2
+                  ENDIF
+               ELSE
+                  patho_case(ji,jj,jl) = 3
+                  IF( old_v_i(ji,jj,jl) + d_v_i_thd(ji,jj,jl) .LT. epsi10 ) THEN 
+                     patho_case(ji,jj,jl) = 4
+                  ENDIF
+               ENDIF
+             END DO
+         END DO
+      END DO
+
+
+      !--------------------------------------
+      ! 2. Review of all pathological cases
+      !--------------------------------------
+
+
+      !----------------------------------------------------
+      ! 2.2) Rebin categories with thickness out of bounds
+      !----------------------------------------------------
+      DO jm = 1, jpm
+         jbnd1 = ice_cat_bounds(jm,1)
+         jbnd2 = ice_cat_bounds(jm,2)
+         IF (ice_ncat_types(jm) .GT. 1 )   CALL lim_itd_th_reb(jbnd1, jbnd2, jm)
+      END DO
+
+      !---------------------------------
+      ! 2.3) Melt of an internal layer
+      !---------------------------------
+      internal_melt(:,:,:) = 0
+
+      DO jl = 1, jpl
+         DO jk = 1, nlay_i
+            DO jj = 1, jpj 
+               DO ji = 1, jpi
+                  ztmelts = - tmut * s_i(ji,jj,jk,jl) + rtt
+                  IF ( ( ( e_i(ji,jj,jk,jl) .LE. 0.0 ) .OR. ( t_i(ji,jj,jk,jl) .GE. ztmelts ) ) &
+                    & .AND. ( v_i(ji,jj,jl) .GT. 0.0 ) .AND. ( a_i(ji,jj,jl) .GT. 0.0 ) ) THEN
+                     internal_melt(ji,jj,jl) = 1
+                  ENDIF
+               END DO ! ji
+            END DO ! jj
+         END DO !jk
+      END DO !jl
+
+      DO jl = 1, jpl
+         DO jj = 1, jpj 
+            DO ji = 1, jpi
+               IF( internal_melt(ji,jj,jl) == 1 ) THEN
+                  ! initial ice thickness
+                  !-----------------------
+                  ht_i(ji,jj,jl) = v_i(ji,jj,jl) / a_i(ji,jj,jl)
+
+                  ! reduce ice thickness
+                  !-----------------------
+                  ind_im = 0
+                  zesum = 0.0
+                  DO jk = 1, nlay_i
+                     ztmelts = - tmut * s_i(ji,jj,jk,jl) + rtt
+                     IF ( ( e_i(ji,jj,jk,jl) .LE. 0.0 ) .OR. ( t_i(ji,jj,jk,jl) .GE. ztmelts ) ) ind_im = ind_im + 1
+                     zesum = zesum + e_i(ji,jj,jk,jl)
+                  END DO
+                  IF (ind_im .LT. nlay_i ) THEN
+                     smv_i(ji,jj,jl) = smv_i(ji,jj,jl) / ht_i(ji,jj,jl) * ( ht_i(ji,jj,jl) - REAL(ind_im)*ht_i(ji,jj,jl) / REAL(nlay_i) )
+                  ENDIF
+                  ht_i(ji,jj,jl) = ht_i(ji,jj,jl) - REAL(ind_im)*ht_i(ji,jj,jl) / REAL(nlay_i)
+                  v_i(ji,jj,jl)  = ht_i(ji,jj,jl) * a_i(ji,jj,jl)
+
+                  !CLEM
+                  zdvres = REAL(ind_im)*ht_i(ji,jj,jl) / REAL(nlay_i) * a_i(ji,jj,jl)
+                  !rdmicif(ji,jj) = rdmicif(ji,jj) - zdvres * rhoic
+                  !fsalt_res(ji,jj)  = fsalt_res(ji,jj) + sm_i(ji,jj,jl) * ( rhoic * zdvres / rdt_ice )
+
+                  ! redistribute heat
+                  !-----------------------
+                  ! old thicknesses and enthalpies
+                  ind_im = 0
+                  DO jk = 1, nlay_i
+                     ztmelts = - tmut * s_i(ji,jj,jk,jl) + rtt
+                     IF ( ( e_i(ji,jj,jk,jl) .GT. 0.0 ) .AND.  & 
+                        ( t_i(ji,jj,jk,jl) .LT. ztmelts ) ) THEN
+                        ind_im = ind_im + 1
+                        zthick0(ind_im) = ht_i(ji,jj,jl) * REAL(ind_im / nlay_i)
+                        zqm0   (ind_im) = MAX( e_i(ji,jj,jk,jl) , 0.0 )
+                     ENDIF
+                  END DO
+
+                  ! Redistributing energy on the new grid
+                  IF ( ind_im .GT. 0 ) THEN
+
+                     DO jk = 1, nlay_i
+                        e_i(ji,jj,jk,jl) = 0.0
+                        DO layer = 1, ind_im
+                           zweight         = MAX (  &
+                              MIN( ht_i(ji,jj,jl) * REAL(layer/ind_im) , ht_i(ji,jj,jl) * REAL(jk / nlay_i) ) -       &
+                              MAX( ht_i(ji,jj,jl) * REAL((layer-1)/ind_im) , ht_i(ji,jj,jl) * REAL((jk-1) / nlay_i) ) , 0.0 ) &
+                              /  ( ht_i(ji,jj,jl) / REAL(ind_im) )
+
+                           e_i(ji,jj,jk,jl) =  e_i(ji,jj,jk,jl) + zweight*zqm0(layer)
+                        END DO !layer
+                     END DO ! jk
+
+                     zesum = 0.0
+                     DO jk = 1, nlay_i
+                        zesum = zesum + e_i(ji,jj,jk,jl)
+                     END DO
+
+                  ELSE ! ind_im .EQ. 0, total melt
+                     e_i(ji,jj,jk,jl) = 0.0
+                  ENDIF
+
+               ENDIF ! internal_melt
+
+            END DO ! ji
+         END DO !jj
+      END DO !jl
+
+      internal_melt(:,:,:) = 0
+
+
+      ! Melt of snow
+      !--------------
+      DO jl = 1, jpl
+         DO jj = 1, jpj 
+            DO ji = 1, jpi
+               ! snow energy of melting
+               ze_s = e_s(ji,jj,1,jl) * unit_fac / area(ji,jj) / MAX( v_s(ji,jj,jl), 1.0e-6 )  ! snow energy of melting
+
+               ! If snow energy of melting smaller then Lf
+               ! Then all snow melts and meltwater, heat go to the ocean
+               IF ( ze_s .LE. rhosn * lfus ) internal_melt(ji,jj,jl) = 1
+
+            END DO
+         END DO
+      END DO
+
+      DO jl = 1, jpl
+         DO jj = 1, jpj 
+            DO ji = 1, jpi
+               IF ( internal_melt(ji,jj,jl) == 1 ) THEN
+                  zdvres = v_s(ji,jj,jl)
+                  ! release heat
+                  fheat_res(ji,jj) = fheat_res(ji,jj) + ze_s * zdvres / rdt_ice
+                  ! release mass
+                  !rdmsnif(ji,jj) =  rdmsnif(ji,jj) - zdvres * rhosn
+                  !
+                  v_s(ji,jj,jl)   = 0.0
+                  e_s(ji,jj,1,jl) = 0.0
+                 ENDIF
+            END DO
+         END DO
+      END DO
+
+      zbigvalue      = 1.0e+20
+      DO jl = 1, jpl
+         DO jj = 1, jpj 
+            DO ji = 1, jpi
+
+               !switches
+               zindb         = MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi06 ) ) 
+               !switch = 1 if a_i > 1e-06 and 0 if not
+               zindsn        = MAX( rzero, SIGN( rone, v_s(ji,jj,jl) - epsi06 ) ) !=1 if hs > 1e-6 and 0 if not
+               zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi04 ) ) !=1 if hi > 1e-3 and 0 if not
+               ! bug fix 25 avril 2007
+               zindb         = zindb*zindic
+
+               !--- 2.3 Correction to ice age 
+               !------------------------------
+               !                IF ((o_i(ji,jj,jl)-1.0)*86400.0.gt.(rdt_ice*float(numit))) THEN
+               !                   o_i(ji,jj,jl) = rdt_ice*FLOAT(numit)/86400.0
+               !                ENDIF
+               IF ((oa_i(ji,jj,jl)-1.0)*86400.0.gt.(rdt_ice*numit*a_i(ji,jj,jl))) THEN
+                  oa_i(ji,jj,jl) = rdt_ice*numit/86400.0*a_i(ji,jj,jl)
+               ENDIF
+               oa_i(ji,jj,jl) = zindb*zindic*oa_i(ji,jj,jl)
+
+               !--- 2.4 Correction to snow thickness
+               !-------------------------------------
+               zdvres = (zindsn * zindb - 1._wp) * v_s(ji,jj,jl)
+               v_s(ji,jj,jl) = v_s(ji,jj,jl) + zdvres
+
+               !rdmsnif(ji,jj) = rdmsnif(ji,jj) + zdvres * rhosn
+ 
+               !--- 2.5 Correction to ice thickness
+               !-------------------------------------
+               zdvres = (zindb - 1._wp) * v_i(ji,jj,jl)
+               v_i(ji,jj,jl) = v_i(ji,jj,jl) + zdvres
+
+               !rdmicif(ji,jj) = rdmicif(ji,jj) + zdvres * rhoic
+               !fsalt_res(ji,jj)  = fsalt_res(ji,jj) - sm_i(ji,jj,jl) * ( rhoic * zdvres / rdt_ice )
+
+               !--- 2.6 Snow is transformed into ice if the original ice cover disappears
+               !----------------------------------------------------------------------------
+               zindg          = tms(ji,jj) *  MAX( 0._wp, SIGN( 1._wp, -v_i(ji,jj,jl) ) )
+               zdvres         = zindg * rhosn * v_s(ji,jj,jl) / rau0
+               v_i(ji,jj,jl)  = v_i(ji,jj,jl)  + zdvres
+
+               zdvres         = - zindg * v_s(ji,jj,jl) + zindg * v_i(ji,jj,jl) * ( rau0 - rhoic ) / rhosn
+               v_s(ji,jj,jl)  = v_s(ji,jj,jl)  + zdvres
+
+               !--- 2.7 Correction to ice concentrations 
+               !--------------------------------------------
+               !clem a_i(ji,jj,jl) = zindb * MAX(zindsn, zindic) * MAX( a_i(ji,jj,jl), epsi06 )
+               a_i(ji,jj,jl) = zindb * a_i(ji,jj,jl)
+
+               !-------------------------
+               ! 2.8) Snow heat content
+               !-------------------------
+               e_s(ji,jj,1,jl) = zindsn * ( MIN ( MAX ( 0.0, e_s(ji,jj,1,jl) ), zbigvalue ) )
+
+            END DO ! ji
+         END DO ! jj
+      END DO ! jl
+
+      !------------------------
+      ! 2.9) Ice heat content 
+      !------------------------
+
+      DO jl = 1, jpl
+         DO jk = 1, nlay_i
+            DO jj = 1, jpj 
+               DO ji = 1, jpi
+                  zindic        = MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi04 ) ) 
+                  e_i(ji,jj,jk,jl)= zindic * ( MIN ( MAX ( 0.0, e_i(ji,jj,jk,jl) ), zbigvalue ) )
+               END DO ! ji
+            END DO ! jj
+         END DO !jk
+      END DO !jl
+
+
+      DO jm = 1, jpm
+         DO jj = 1, jpj 
+            DO ji = 1, jpi
+               jl = ice_cat_bounds(jm,1)
+               !--- 2.12 Constrain the thickness of the smallest category above 5 cm
+               !----------------------------------------------------------------------
+               zindb         = MAX( rzero, SIGN( rone, a_i(ji,jj,jl) - epsi06 ) ) 
+               ht_i(ji,jj,jl) = zindb*v_i(ji,jj,jl)/MAX(a_i(ji,jj,jl), epsi06)
+               zh            = MAX( rone , zindb * hiclim  / MAX( ht_i(ji,jj,jl) , epsi20 ) )
+               ht_s(ji,jj,jl) = ht_s(ji,jj,jl)* zh
+               ht_i(ji,jj,jl) = ht_i(ji,jj,jl)* zh
+               a_i (ji,jj,jl) = a_i(ji,jj,jl) / zh
+               !CLEM
+               v_i (ji,jj,jl) = a_i(ji,jj,jl) * ht_i(ji,jj,jl)
+               v_s (ji,jj,jl) = a_i(ji,jj,jl) * ht_s(ji,jj,jl)
+            END DO !ji
+         END DO !jj
+      END DO !jm
+
+      at_i(:,:) = 0.0
+      DO jl = 1, jpl
+         at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
+      END DO
+      
+      !--- 2.13 ice concentration should not exceed amax 
+      !-----------------------------------------------------
+      DO jj = 1, jpj
+         DO ji = 1, jpi
+            z_da_ex =  MAX( at_i(ji,jj) - amax , 0.0 )        
+            DO jl  = 1, jpl
+               zindb   =  MAX( rzero, SIGN( rone, v_i(ji,jj,jl) - epsi04 ) ) 
+               z_da_i = a_i(ji,jj,jl) * z_da_ex / MAX( at_i(ji,jj), epsi06 ) * zindb
+               a_i(ji,jj,jl) = a_i(ji,jj,jl) - z_da_i
+            END DO
+         END DO
+      END DO
+      at_i(:,:) = 0.0
+      DO jl = 1, jpl
+         at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
+      END DO
+
+      ! Final thickness distribution rebinning
+      ! --------------------------------------
+      DO jm = 1, jpm
+         jbnd1 = ice_cat_bounds(jm,1)
+         jbnd2 = ice_cat_bounds(jm,2)
+         IF (ice_ncat_types(jm) .GT. 1 ) CALL lim_itd_th_reb(jbnd1, jbnd2, jm)
+         IF (ice_ncat_types(jm) .EQ. 1 ) THEN
+         ENDIF
+      END DO
+
+      !---------------------
+      ! 2.11) Ice salinity
+      !---------------------
+      !clem@bug: smv_i should be updated too: smv_i(:,:,:) = smv_i(:,:,:) + sm_i(:,:,:) * ( v_i(:,:,:) - zviold(:,:,:) )
+      IF ( ( num_sal .EQ. 2 ) .OR. ( num_sal .EQ. 4 ) ) THEN ! general case
+         DO jl = 1, jpl
+            !DO jk = 1, nlay_i
+               DO jj = 1, jpj 
+                  DO ji = 1, jpi
+                     ! salinity stays in bounds
+                     smv_i(ji,jj,jl)  =  MAX(MIN((rhoic-rhosn)/rhoic*sss_m(ji,jj),smv_i(ji,jj,jl)),0.1 * v_i(ji,jj,jl) )
+                     i_ice_switch    =  1.0-MAX(0.0,SIGN(1.0,-v_i(ji,jj,jl) + epsi20))
+                     smv_i(ji,jj,jl)  = i_ice_switch*smv_i(ji,jj,jl) + 0.1*(1.0-i_ice_switch)*v_i(ji,jj,jl)
+                  END DO ! ji
+               END DO ! jj
+            !END DO !jk
+         END DO !jl
+      ENDIF
+
+      ! -------------------
+      at_i(:,:) = a_i(:,:,1)
+      DO jl = 2, jpl
+         at_i(:,:) = a_i(:,:,jl) + at_i(:,:)
+      END DO
+
+      !------------------------------------------------------------------------------
+      ! 2) Corrections to avoid wrong values                                        |
+      !------------------------------------------------------------------------------
+      ! Ice drift
+      !------------
+      DO jj = 2, jpjm1
+         DO ji = fs_2, fs_jpim1
+            IF ( at_i(ji,jj) .EQ. 0.0 ) THEN ! what to do if there is no ice
+               IF ( at_i(ji+1,jj) .EQ. 0.0 ) u_ice(ji,jj)   = 0.0 ! right side
+               IF ( at_i(ji-1,jj) .EQ. 0.0 ) u_ice(ji-1,jj) = 0.0 ! left side
+               IF ( at_i(ji,jj+1) .EQ. 0.0 ) v_ice(ji,jj)   = 0.0 ! upper side
+               IF ( at_i(ji,jj-1) .EQ. 0.0 ) v_ice(ji,jj-1) = 0.0 ! bottom side
+            ENDIF
+         END DO
+      END DO
+      !mask velocities
+      u_ice(:,:) = u_ice(:,:) * tmu(:,:)
+      v_ice(:,:) = v_ice(:,:) * tmv(:,:)
+      !lateral boundary conditions
+      CALL lbc_lnk( u_ice(:,:), 'U', -1. )
+      CALL lbc_lnk( v_ice(:,:), 'V', -1. )
+ 
+      !--------------------------------
+      ! Update mass/salt fluxes (clem)
+      !--------------------------------
+      DO jl = 1, jpl
+         DO jj = 1, jpj 
+            DO ji = 1, jpi
+               diag_res_pr(ji,jj) = diag_res_pr(ji,jj) + ( v_i(ji,jj,jl) - zviold(ji,jj,jl) ) / rdt_ice 
+               rdmicif(ji,jj) = rdmicif(ji,jj) + ( v_i(ji,jj,jl) - zviold(ji,jj,jl) ) * rhoic 
+               rdmsnif(ji,jj) = rdmsnif(ji,jj) + ( v_s(ji,jj,jl) - zvsold(ji,jj,jl) ) * rhosn 
+               fsalt_res(ji,jj) = fsalt_res(ji,jj) - ( smv_i(ji,jj,jl) - zsmvold(ji,jj,jl) ) * rhoic / rdt_ice 
+            END DO
+         END DO
+      END DO
+
+      ! -------------------------------
+      !- check conservation (C Rousset)
+      IF (ln_limdiahsb) THEN
+         zchk_fs  = glob_sum( ( fsbri(:,:) + fseqv(:,:) + fsalt_res(:,:) + fsalt_rpo(:,:) ) * area(:,:) * tms(:,:) ) - zchk_fs_b
+         zchk_fw  = glob_sum( rdmicif(:,:) * area(:,:) * tms(:,:) ) - zchk_fw_b
+ 
+         zchk_v_i = ( glob_sum( SUM(   v_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_v_i_b - ( zchk_fw / rhoic ) ) / rdt_ice
+         zchk_smv = ( glob_sum( SUM( smv_i(:,:,:), dim=3 ) * area(:,:) * tms(:,:) ) - zchk_smv_b ) / rdt_ice + ( zchk_fs / rhoic )
+
+         IF(lwp) THEN
+            IF (    ABS( zchk_v_i   ) >  1.e-5 ) WRITE(numout,*) 'violation volume [m3/day]     (limupdate2) = ',(zchk_v_i * 86400.)
+            IF (    ABS( zchk_smv   ) >  1.e-4 ) WRITE(numout,*) 'violation saline [psu*m3/day] (limupdate2) = ',(zchk_smv * 86400.)
+            IF ( MINVAL( v_i(:,:,:) ) <  0.    ) WRITE(numout,*) 'violation v_i<0  [mm]         (limupdate2) = ',(MINVAL(v_i) * 1.e-3)
+            IF ( MAXVAL( SUM(a_i(:,:,:),dim=3) ) > amax+epsi10 ) WRITE(numout,*) 'violation a_i>amax    (limupdate2) = ',MAXVAL(SUM(a_i,dim=3))
+            IF ( MINVAL( a_i(:,:,:) ) <  0.    ) WRITE(numout,*) 'violation a_i<0               (limupdate2) = ',MINVAL(a_i)
+         ENDIF
+      ENDIF
+      !- check conservation (C Rousset)
+      ! -------------------------------
+
+      IF(ln_ctl) THEN   ! Control print
+         CALL prt_ctl_info(' ')
+         CALL prt_ctl_info(' - Cell values : ')
+         CALL prt_ctl_info('   ~~~~~~~~~~~~~ ')
+         CALL prt_ctl(tab2d_1=area       , clinfo1=' lim_update2  : cell area   :')
+         CALL prt_ctl(tab2d_1=at_i       , clinfo1=' lim_update2  : at_i        :')
+         CALL prt_ctl(tab2d_1=vt_i       , clinfo1=' lim_update2  : vt_i        :')
+         CALL prt_ctl(tab2d_1=vt_s       , clinfo1=' lim_update2  : vt_s        :')
+         CALL prt_ctl(tab2d_1=strength   , clinfo1=' lim_update2  : strength    :')
+         CALL prt_ctl(tab2d_1=u_ice      , clinfo1=' lim_update2  : u_ice       :', tab2d_2=v_ice      , clinfo2=' v_ice       :')
+         CALL prt_ctl(tab2d_1=old_u_ice  , clinfo1=' lim_update2  : old_u_ice   :', tab2d_2=old_v_ice  , clinfo2=' old_v_ice   :')
+
+         DO jl = 1, jpl
+            CALL prt_ctl_info(' ')
+            CALL prt_ctl_info(' - Category : ', ivar1=jl)
+            CALL prt_ctl_info('   ~~~~~~~~~~')
+            CALL prt_ctl(tab2d_1=ht_i       (:,:,jl)        , clinfo1= ' lim_update2  : ht_i        : ')
+            CALL prt_ctl(tab2d_1=ht_s       (:,:,jl)        , clinfo1= ' lim_update2  : ht_s        : ')
+            CALL prt_ctl(tab2d_1=t_su       (:,:,jl)        , clinfo1= ' lim_update2  : t_su        : ')
+            CALL prt_ctl(tab2d_1=t_s        (:,:,1,jl)      , clinfo1= ' lim_update2  : t_snow      : ')
+            CALL prt_ctl(tab2d_1=sm_i       (:,:,jl)        , clinfo1= ' lim_update2  : sm_i        : ')
+            CALL prt_ctl(tab2d_1=o_i        (:,:,jl)        , clinfo1= ' lim_update2  : o_i         : ')
+            CALL prt_ctl(tab2d_1=a_i        (:,:,jl)        , clinfo1= ' lim_update2  : a_i         : ')
+            CALL prt_ctl(tab2d_1=old_a_i    (:,:,jl)        , clinfo1= ' lim_update2  : old_a_i     : ')
+            CALL prt_ctl(tab2d_1=d_a_i_thd  (:,:,jl)        , clinfo1= ' lim_update2  : d_a_i_thd   : ')
+            CALL prt_ctl(tab2d_1=v_i        (:,:,jl)        , clinfo1= ' lim_update2  : v_i         : ')
+            CALL prt_ctl(tab2d_1=old_v_i    (:,:,jl)        , clinfo1= ' lim_update2  : old_v_i     : ')
+            CALL prt_ctl(tab2d_1=d_v_i_thd  (:,:,jl)        , clinfo1= ' lim_update2  : d_v_i_thd   : ')
+            CALL prt_ctl(tab2d_1=v_s        (:,:,jl)        , clinfo1= ' lim_update2  : v_s         : ')
+            CALL prt_ctl(tab2d_1=old_v_s    (:,:,jl)        , clinfo1= ' lim_update2  : old_v_s     : ')
+            CALL prt_ctl(tab2d_1=d_v_s_thd  (:,:,jl)        , clinfo1= ' lim_update2  : d_v_s_thd   : ')
+            CALL prt_ctl(tab2d_1=e_i        (:,:,1,jl)/1.0e9, clinfo1= ' lim_update2  : e_i1        : ')
+            CALL prt_ctl(tab2d_1=old_e_i    (:,:,1,jl)/1.0e9, clinfo1= ' lim_update2  : old_e_i1    : ')
+            CALL prt_ctl(tab2d_1=d_e_i_thd  (:,:,1,jl)/1.0e9, clinfo1= ' lim_update2  : de_i1_thd   : ')
+            CALL prt_ctl(tab2d_1=e_i        (:,:,2,jl)/1.0e9, clinfo1= ' lim_update2  : e_i2        : ')
+            CALL prt_ctl(tab2d_1=old_e_i    (:,:,2,jl)/1.0e9, clinfo1= ' lim_update2  : old_e_i2    : ')
+            CALL prt_ctl(tab2d_1=d_e_i_thd  (:,:,2,jl)/1.0e9, clinfo1= ' lim_update2  : de_i2_thd   : ')
+            CALL prt_ctl(tab2d_1=e_s        (:,:,1,jl)      , clinfo1= ' lim_update2  : e_snow      : ')
+            CALL prt_ctl(tab2d_1=old_e_s    (:,:,1,jl)      , clinfo1= ' lim_update2  : old_e_snow  : ')
+            CALL prt_ctl(tab2d_1=d_e_s_thd  (:,:,1,jl)/1.0e9, clinfo1= ' lim_update2  : d_e_s_thd   : ')
+            CALL prt_ctl(tab2d_1=smv_i      (:,:,jl)        , clinfo1= ' lim_update2  : smv_i       : ')
+            CALL prt_ctl(tab2d_1=old_smv_i  (:,:,jl)        , clinfo1= ' lim_update2  : old_smv_i   : ')
+            CALL prt_ctl(tab2d_1=d_smv_i_thd(:,:,jl)        , clinfo1= ' lim_update2  : d_smv_i_thd : ')
+            CALL prt_ctl(tab2d_1=oa_i       (:,:,jl)        , clinfo1= ' lim_update2  : oa_i        : ')
+            CALL prt_ctl(tab2d_1=old_oa_i   (:,:,jl)        , clinfo1= ' lim_update2  : old_oa_i    : ')
+            CALL prt_ctl(tab2d_1=d_oa_i_thd (:,:,jl)        , clinfo1= ' lim_update2  : d_oa_i_thd  : ')
+            CALL prt_ctl(tab2d_1=REAL(patho_case(:,:,jl))   , clinfo1= ' lim_update2  : Path. case  : ')
+
+            DO jk = 1, nlay_i
+               CALL prt_ctl_info(' - Layer : ', ivar1=jk)
+               CALL prt_ctl(tab2d_1=t_i(:,:,jk,jl) , clinfo1= ' lim_update2  : t_i       : ')
+            END DO
+         END DO
+
+         CALL prt_ctl_info(' ')
+         CALL prt_ctl_info(' - Heat / FW fluxes : ')
+         CALL prt_ctl_info('   ~~~~~~~~~~~~~~~~~~ ')
+         CALL prt_ctl(tab2d_1=fmmec  , clinfo1= ' lim_update2 : fmmec : ', tab2d_2=fhmec     , clinfo2= ' fhmec     : ')
+         CALL prt_ctl(tab2d_1=sst_m  , clinfo1= ' lim_update2 : sst   : ', tab2d_2=sss_m     , clinfo2= ' sss       : ')
+         CALL prt_ctl(tab2d_1=fhbri  , clinfo1= ' lim_update2 : fhbri : ', tab2d_2=fheat_rpo , clinfo2= ' fheat_rpo : ')
+
+         CALL prt_ctl_info(' ')
+         CALL prt_ctl_info(' - Stresses : ')
+         CALL prt_ctl_info('   ~~~~~~~~~~ ')
+         CALL prt_ctl(tab2d_1=utau       , clinfo1= ' lim_update2 : utau      : ', tab2d_2=vtau       , clinfo2= ' vtau      : ')
+         CALL prt_ctl(tab2d_1=utau_ice   , clinfo1= ' lim_update2 : utau_ice  : ', tab2d_2=vtau_ice   , clinfo2= ' vtau_ice  : ')
+         CALL prt_ctl(tab2d_1=u_oce      , clinfo1= ' lim_update2 : u_oce     : ', tab2d_2=v_oce      , clinfo2= ' v_oce     : ')
+      ENDIF
+   
+      CALL wrk_dealloc( jpi,jpj,jpl, internal_melt )   ! integer
+      CALL wrk_dealloc( jkmax, zthick0, zqm0 )
+
+      CALL wrk_dealloc( jpi,jpj,jpl,zviold, zvsold, zsmvold )   ! clem
+
+   END SUBROUTINE lim_update2
+#else
+   !!----------------------------------------------------------------------
+   !!   Default option         Empty Module               No sea-ice model
+   !!----------------------------------------------------------------------
+CONTAINS
+   SUBROUTINE lim_update2     ! Empty routine
+   END SUBROUTINE lim_update2
+
+#endif
+
+END MODULE limupdate2
